diff --git a/src/util-mpm-b3g.c b/src/util-mpm-b3g.c
index 2d532d4..12d046a 100644
--- a/src/util-mpm-b3g.c
+++ b/src/util-mpm-b3g.c
@@ -20,8 +20,6 @@
 #include "conf.h"
 #include "util-debug.h"
 
-#define INIT_HASH_SIZE 65536
-
 #ifdef B3G_COUNTERS
 #define COUNT(counter) \
         (counter)
@@ -43,8 +41,6 @@ int B3gAddScanPatternCS(MpmCtx *, uint8_t *, uint16_t, uint16_t, uint16_t, uint3
 int B3gAddPatternCI(MpmCtx *, uint8_t *, uint16_t, uint16_t, uint16_t, uint32_t, uint32_t);
 int B3gAddPatternCS(MpmCtx *, uint8_t *, uint16_t, uint16_t, uint16_t, uint32_t, uint32_t);
 int B3gPreparePatterns(MpmCtx *);
-inline uint32_t B3gScanWrap(MpmCtx *, MpmThreadCtx *, PatternMatcherQueue *, uint8_t *, uint16_t);
-inline uint32_t B3gSearchWrap(MpmCtx *, MpmThreadCtx *, PatternMatcherQueue *, uint8_t *, uint16_t);
 uint32_t B3gScan1(MpmCtx *, MpmThreadCtx *, PatternMatcherQueue *, uint8_t *, uint16_t);
 uint32_t B3gScan2(MpmCtx *, MpmThreadCtx *, PatternMatcherQueue *, uint8_t *, uint16_t);
 uint32_t B3gScan12(MpmCtx *, MpmThreadCtx *, PatternMatcherQueue *, uint8_t *, uint16_t);
@@ -79,39 +75,6 @@ void MpmB3gRegister (void) {
     mpm_table[MPM_B3G].RegisterUnittests = B3gRegisterTests;
 }
 
-/* append an endmatch to a pattern
- *
- * Only used in the initialization phase */
-static inline void B3gEndMatchAppend(MpmCtx *mpm_ctx, B3gPattern *p,
-    uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid,
-    uint8_t nosearch)
-{
-    MpmEndMatch *em = MpmAllocEndMatch(mpm_ctx);
-    if (em == NULL) {
-        printf("ERROR: B3gAllocEndMatch failed\n");
-        return;
-    }
-
-    em->id = pid;
-    em->sig_id = sid;
-    em->depth = depth;
-    em->offset = offset;
-
-    if (nosearch)
-        em->flags |= MPM_ENDMATCH_NOSEARCH;
-
-    if (p->em == NULL) {
-        p->em = em;
-        return;
-    }
-
-    MpmEndMatch *m = p->em;
-    while (m->next) {
-        m = m->next;
-    }
-    m->next = em;
-}
-
 /** \todo XXX Unused??? */
 #if 0
 static void prt (uint8_t *buf, uint16_t buflen) {
@@ -145,33 +108,6 @@ void B3gPrintInfo(MpmCtx *mpm_ctx) {
     printf("\n");
 }
 
-static inline B3gPattern *B3gAllocPattern(MpmCtx *mpm_ctx) {
-    B3gPattern *p = SCMalloc(sizeof(B3gPattern));
-    if (p == NULL) {
-        printf("ERROR: B3gAllocPattern: SCMalloc failed\n");
-        exit(EXIT_FAILURE);
-    }
-    memset(p,0,sizeof(B3gPattern));
-
-    mpm_ctx->memory_cnt++;
-    mpm_ctx->memory_size += sizeof(B3gPattern);
-    return p;
-}
-
-static inline B3gHashItem *
-B3gAllocHashItem(MpmCtx *mpm_ctx) {
-    B3gHashItem *hi = SCMalloc(sizeof(B3gHashItem));
-    if (hi == NULL) {
-        printf("ERROR: B3gAllocHashItem: SCMalloc failed\n");
-        exit(EXIT_FAILURE);
-    }
-    memset(hi,0,sizeof(B3gHashItem));
-
-    mpm_ctx->memory_cnt++;
-    mpm_ctx->memory_size += sizeof(B3gHashItem);
-    return hi;
-}
-
 static void B3gHashFree(MpmCtx *mpm_ctx, B3gHashItem *hi) {
     if (hi == NULL)
         return;
@@ -184,91 +120,6 @@ static void B3gHashFree(MpmCtx *mpm_ctx, B3gHashItem *hi) {
     SCFree(hi);
 }
 
-static inline void memcpy_tolower(uint8_t *d, uint8_t *s, uint16_t len) {
-    uint16_t i;
-    for (i = 0; i < len; i++) {
-        d[i] = u8_tolower(s[i]);
-    }
-}
-
-/*
- * INIT HASH START
- */
-static inline uint32_t B3gInitHash(B3gPattern *p) {
-    uint32_t hash = p->len * p->cs[0];
-    if (p->len > 1)
-        hash += p->cs[1];
-
-    return (hash % INIT_HASH_SIZE);
-}
-
-static inline uint32_t B3gInitHashRaw(uint8_t *pat, uint16_t patlen) {
-    uint32_t hash = patlen * pat[0];
-    if (patlen > 1)
-        hash += pat[1];
-
-    return (hash % INIT_HASH_SIZE);
-}
-
-static inline int B3gInitHashAdd(B3gCtx *ctx, B3gPattern *p) {
-    uint32_t hash = B3gInitHash(p);
-
-    //printf("B3gInitHashAdd: %" PRIu32 "\n", hash);
-
-    if (ctx->init_hash[hash] == NULL) {
-        ctx->init_hash[hash] = p;
-        //printf("B3gInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
-        return 0;
-    }
-
-    B3gPattern *tt = NULL;
-    B3gPattern *t = ctx->init_hash[hash];
-
-    /* get the list tail */
-    do {
-        tt = t;
-        t = t->next;
-    } while (t != NULL);
-
-    tt->next = p;
-    //printf("B3gInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
-
-    return 0;
-}
-
-static inline int B3gCmpPattern(B3gPattern *p, uint8_t *pat, uint16_t patlen, char nocase);
-
-static inline B3gPattern *B3gInitHashLookup(B3gCtx *ctx, uint8_t *pat, uint16_t patlen, char nocase) {
-    uint32_t hash = B3gInitHashRaw(pat,patlen);
-
-    //printf("B3gInitHashLookup: %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
-
-    if (ctx->init_hash[hash] == NULL) {
-        return NULL;
-    }
-
-    B3gPattern *t = ctx->init_hash[hash];
-    for ( ; t != NULL; t = t->next) {
-        if (B3gCmpPattern(t,pat,patlen,nocase) == 1)
-            return t;
-    }
-
-    return NULL;
-}
-
-static inline int B3gCmpPattern(B3gPattern *p, uint8_t *pat, uint16_t patlen, char nocase) {
-    if (p->len != patlen)
-        return 0;
-
-    if (!((nocase && p->flags & B3G_NOCASE) || (!nocase && !(p->flags & B3G_NOCASE))))
-        return 0;
-
-    if (memcmp(p->cs, pat, patlen) != 0)
-        return 0;
-
-    return 1;
-}
-
 /*
  * INIT HASH END
  */
@@ -297,107 +148,6 @@ void B3gFreePattern(MpmCtx *mpm_ctx, B3gPattern *p) {
     }
 }
 
-/* B3gAddPattern
- *
- * pat: ptr to the pattern
- * patlen: length of the pattern
- * nocase: nocase flag: 1 enabled, 0 disable
- * pid: pattern id
- * sid: signature id (internal id)
- */
-static inline int B3gAddPattern(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen, uint16_t offset, uint16_t depth, char nocase, char scan, uint32_t pid, uint32_t sid, uint8_t nosearch) {
-    B3gCtx *ctx = (B3gCtx *)mpm_ctx->ctx;
-
-//    printf("B3gAddPattern: ctx %p \"", mpm_ctx); prt(pat, patlen);
-//    printf("\" id %" PRIu32 ", nocase %s\n", id, nocase ? "true" : "false");
-
-    if (patlen == 0)
-        return 0;
-
-    /* get a memory piece */
-    B3gPattern *p = B3gInitHashLookup(ctx, pat, patlen, nocase);
-    if (p == NULL) {
-//        printf("B3gAddPattern: allocing new pattern\n");
-        p = B3gAllocPattern(mpm_ctx);
-        if (p == NULL)
-            goto error;
-
-        p->len = patlen;
-
-        if (nocase) p->flags |= B3G_NOCASE;
-
-        /* setup the case insensitive part of the pattern */
-        p->ci = SCMalloc(patlen);
-        if (p->ci == NULL) goto error;
-        mpm_ctx->memory_cnt++;
-        mpm_ctx->memory_size += patlen;
-        memcpy_tolower(p->ci, pat, patlen);
-
-        /* setup the case sensitive part of the pattern */
-        if (p->flags & B3G_NOCASE) {
-            /* nocase means no difference between cs and ci */
-            p->cs = p->ci;
-        } else {
-            if (memcmp(p->ci,pat,p->len) == 0) {
-                /* no diff between cs and ci: pat is lowercase */
-                p->cs = p->ci;
-            } else {
-                p->cs = SCMalloc(patlen);
-                if (p->cs == NULL) goto error;
-                mpm_ctx->memory_cnt++;
-                mpm_ctx->memory_size += patlen;
-                memcpy(p->cs, pat, patlen);
-            }
-        }
-
-        //printf("B3gAddPattern: ci \""); prt(p->ci,p->len);
-        //printf("\" cs \""); prt(p->cs,p->len);
-        //printf("\" prefix_ci %" PRIu32 ", prefix_cs %" PRIu32 "\n", p->prefix_ci, p->prefix_cs);
-
-        /* put in the pattern hash */
-        B3gInitHashAdd(ctx, p);
-
-        if (mpm_ctx->pattern_cnt == 65535) {
-            printf("Max search words reached\n");
-            exit(1);
-        }
-        if (scan) mpm_ctx->scan_pattern_cnt++;
-        mpm_ctx->pattern_cnt++;
-
-        if (scan) { /* SCAN */
-            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
-            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
-            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
-            p->flags |= B3G_SCAN;
-        } else { /* SEARCH */
-            if (mpm_ctx->search_maxlen < patlen) mpm_ctx->search_maxlen = patlen;
-            if (mpm_ctx->search_minlen == 0) mpm_ctx->search_minlen = patlen;
-            else if (mpm_ctx->search_minlen > patlen) mpm_ctx->search_minlen = patlen;
-        }
-    } else {
-        /* if we're reusing a pattern, check we need to check that it is a
-         * scan pattern if that is what we're adding. If so we set the pattern
-         * to be a scan pattern. */
-        if (scan) {
-            p->flags |= B3G_SCAN;
-
-            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
-            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
-            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
-        }
-    }
-
-    /* we need a match */
-    B3gEndMatchAppend(mpm_ctx, p, offset, depth, pid, sid, nosearch);
-
-    mpm_ctx->total_pattern_cnt++;
-    return 0;
-
-error:
-    B3gFreePattern(mpm_ctx, p);
-    return -1;
-}
-
 int B3gAddScanPatternCI(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen,
     uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid, uint8_t nosearch)
 {
@@ -916,21 +666,6 @@ void B3gPrintSearchStats(MpmThreadCtx *mpm_thread_ctx) {
 #endif /* B3G_COUNTERS */
 }
 
-static inline int
-memcmp_lowercase(uint8_t *s1, uint8_t *s2, uint16_t n) {
-    size_t i;
-
-    /* check backwards because we already tested the first
-     * 2 to 4 chars. This way we are more likely to detect
-     * a miss and thus speed up a little... */
-    for (i = n - 1; i; i--) {
-        if (u8_tolower(*(s2+i)) != s1[i])
-            return 1;
-    }
-
-    return 0;
-}
-
 /**
  * \brief   Function to get the user defined values for b3g algorithm from the
  *          config file 'suricata.yaml'
@@ -1221,16 +956,6 @@ void B3gThreadDestroyCtx(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx) {
     MpmMatchFreeSpares(mpm_thread_ctx, mpm_thread_ctx->qlist);
 }
 
-inline uint32_t B3gScanWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
-    B3gCtx *ctx = (B3gCtx *)mpm_ctx->ctx;
-    return ctx->Scan(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen);
-}
-
-inline uint32_t B3gSearchWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
-    B3gCtx *ctx = (B3gCtx *)mpm_ctx->ctx;
-    return ctx->Search(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen);
-}
-
 uint32_t B3gScanBNDMq(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
     B3gCtx *ctx = (B3gCtx *)mpm_ctx->ctx;
 #ifdef B3G_COUNTERS
diff --git a/src/util-mpm-b3g.h b/src/util-mpm-b3g.h
index 20eed69..4eccdeb 100644
--- a/src/util-mpm-b3g.h
+++ b/src/util-mpm-b3g.h
@@ -3,10 +3,14 @@
 
 #include "util-mpm.h"
 #include "util-bloomfilter.h"
+#include "suricata.h"
+#include "suricata-common.h"
 
 #define B3G_NOCASE 0x01
 #define B3G_SCAN   0x02
 
+#define INIT_HASH_SIZE 65536
+
 //#define B3G_HASHSHIFT 8
 //#define B3G_HASHSHIFT 7
 //#define B3G_HASHSHIFT 6
@@ -123,6 +127,287 @@ typedef struct B3gThreadCtx_ {
 
 void MpmB3gRegister(void);
 
+/** ---- Inline functions ---- */
+
+static inline uint32_t B3gScanWrap(MpmCtx *, MpmThreadCtx *, PatternMatcherQueue *, uint8_t *, uint16_t);
+static inline uint32_t B3gSearchWrap(MpmCtx *, MpmThreadCtx *, PatternMatcherQueue *, uint8_t *, uint16_t);
+void B3gFreePattern(MpmCtx *, B3gPattern *);
+
+/* append an endmatch to a pattern
+ *
+ * Only used in the initialization phase */
+static inline void B3gEndMatchAppend(MpmCtx *mpm_ctx, B3gPattern *p,
+    uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid,
+    uint8_t nosearch)
+{
+    MpmEndMatch *em = MpmAllocEndMatch(mpm_ctx);
+    if (em == NULL) {
+        printf("ERROR: B3gAllocEndMatch failed\n");
+        return;
+    }
+
+    em->id = pid;
+    em->sig_id = sid;
+    em->depth = depth;
+    em->offset = offset;
+
+    if (nosearch)
+        em->flags |= MPM_ENDMATCH_NOSEARCH;
+
+    if (p->em == NULL) {
+        p->em = em;
+        return;
+    }
+
+    MpmEndMatch *m = p->em;
+    while (m->next) {
+        m = m->next;
+    }
+    m->next = em;
+}
+
+static inline B3gPattern *B3gAllocPattern(MpmCtx *mpm_ctx) {
+    B3gPattern *p = SCMalloc(sizeof(B3gPattern));
+    if (p == NULL) {
+        printf("ERROR: B3gAllocPattern: SCMalloc failed\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(p,0,sizeof(B3gPattern));
+
+    mpm_ctx->memory_cnt++;
+    mpm_ctx->memory_size += sizeof(B3gPattern);
+    return p;
+}
+
+static inline B3gHashItem *
+B3gAllocHashItem(MpmCtx *mpm_ctx) {
+    B3gHashItem *hi = SCMalloc(sizeof(B3gHashItem));
+    if (hi == NULL) {
+        printf("ERROR: B3gAllocHashItem: SCMalloc failed\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(hi,0,sizeof(B3gHashItem));
+
+    mpm_ctx->memory_cnt++;
+    mpm_ctx->memory_size += sizeof(B3gHashItem);
+    return hi;
+}
+
+/*
+static inline void memcpy_tolower(uint8_t *d, uint8_t *s, uint16_t len) {
+    uint16_t i;
+    for (i = 0; i < len; i++) {
+        d[i] = u8_tolower(s[i]);
+    }
+}
+*/
+
+/*
+ * INIT HASH START
+ */
+static inline uint32_t B3gInitHash(B3gPattern *p) {
+    uint32_t hash = p->len * p->cs[0];
+    if (p->len > 1)
+        hash += p->cs[1];
+
+    return (hash % INIT_HASH_SIZE);
+}
+
+static inline uint32_t B3gInitHashRaw(uint8_t *pat, uint16_t patlen) {
+    uint32_t hash = patlen * pat[0];
+    if (patlen > 1)
+        hash += pat[1];
+
+    return (hash % INIT_HASH_SIZE);
+}
+
+static inline int B3gInitHashAdd(B3gCtx *ctx, B3gPattern *p) {
+    uint32_t hash = B3gInitHash(p);
+
+    //printf("B3gInitHashAdd: %" PRIu32 "\n", hash);
+
+    if (ctx->init_hash[hash] == NULL) {
+        ctx->init_hash[hash] = p;
+        //printf("B3gInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
+        return 0;
+    }
+
+    B3gPattern *tt = NULL;
+    B3gPattern *t = ctx->init_hash[hash];
+
+    /* get the list tail */
+    do {
+        tt = t;
+        t = t->next;
+    } while (t != NULL);
+
+    tt->next = p;
+    //printf("B3gInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
+
+    return 0;
+}
+
+static inline int B3gCmpPattern(B3gPattern *p, uint8_t *pat, uint16_t patlen, char nocase);
+
+static inline B3gPattern *B3gInitHashLookup(B3gCtx *ctx, uint8_t *pat, uint16_t patlen, char nocase) {
+    uint32_t hash = B3gInitHashRaw(pat,patlen);
+
+    //printf("B3gInitHashLookup: %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
+
+    if (ctx->init_hash[hash] == NULL) {
+        return NULL;
+    }
+
+    B3gPattern *t = ctx->init_hash[hash];
+    for ( ; t != NULL; t = t->next) {
+        if (B3gCmpPattern(t,pat,patlen,nocase) == 1)
+            return t;
+    }
+
+    return NULL;
+}
+
+static inline int B3gCmpPattern(B3gPattern *p, uint8_t *pat, uint16_t patlen, char nocase) {
+    if (p->len != patlen)
+        return 0;
+
+    if (!((nocase && p->flags & B3G_NOCASE) || (!nocase && !(p->flags & B3G_NOCASE))))
+        return 0;
+
+    if (memcmp(p->cs, pat, patlen) != 0)
+        return 0;
+
+    return 1;
+}
+
+/* B3gAddPattern
+ *
+ * pat: ptr to the pattern
+ * patlen: length of the pattern
+ * nocase: nocase flag: 1 enabled, 0 disable
+ * pid: pattern id
+ * sid: signature id (internal id)
+ */
+static inline int B3gAddPattern(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen, uint16_t offset, uint16_t depth, char nocase, char scan, uint32_t pid, uint32_t sid, uint8_t nosearch) {
+    B3gCtx *ctx = (B3gCtx *)mpm_ctx->ctx;
+
+//    printf("B3gAddPattern: ctx %p \"", mpm_ctx); prt(pat, patlen);
+//    printf("\" id %" PRIu32 ", nocase %s\n", id, nocase ? "true" : "false");
+
+    if (patlen == 0)
+        return 0;
+
+    /* get a memory piece */
+    B3gPattern *p = B3gInitHashLookup(ctx, pat, patlen, nocase);
+    if (p == NULL) {
+//        printf("B3gAddPattern: allocing new pattern\n");
+        p = B3gAllocPattern(mpm_ctx);
+        if (p == NULL)
+            goto error;
+
+        p->len = patlen;
+
+        if (nocase) p->flags |= B3G_NOCASE;
+
+        /* setup the case insensitive part of the pattern */
+        p->ci = SCMalloc(patlen);
+        if (p->ci == NULL) goto error;
+        mpm_ctx->memory_cnt++;
+        mpm_ctx->memory_size += patlen;
+        memcpy_tolower(p->ci, pat, patlen);
+
+        /* setup the case sensitive part of the pattern */
+        if (p->flags & B3G_NOCASE) {
+            /* nocase means no difference between cs and ci */
+            p->cs = p->ci;
+        } else {
+            if (memcmp(p->ci,pat,p->len) == 0) {
+                /* no diff between cs and ci: pat is lowercase */
+                p->cs = p->ci;
+            } else {
+                p->cs = SCMalloc(patlen);
+                if (p->cs == NULL) goto error;
+                mpm_ctx->memory_cnt++;
+                mpm_ctx->memory_size += patlen;
+                memcpy(p->cs, pat, patlen);
+            }
+        }
+
+        //printf("B3gAddPattern: ci \""); prt(p->ci,p->len);
+        //printf("\" cs \""); prt(p->cs,p->len);
+        //printf("\" prefix_ci %" PRIu32 ", prefix_cs %" PRIu32 "\n", p->prefix_ci, p->prefix_cs);
+
+        /* put in the pattern hash */
+        B3gInitHashAdd(ctx, p);
+
+        if (mpm_ctx->pattern_cnt == 65535) {
+            printf("Max search words reached\n");
+            exit(1);
+        }
+        if (scan) mpm_ctx->scan_pattern_cnt++;
+        mpm_ctx->pattern_cnt++;
+
+        if (scan) { /* SCAN */
+            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
+            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
+            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
+            p->flags |= B3G_SCAN;
+        } else { /* SEARCH */
+            if (mpm_ctx->search_maxlen < patlen) mpm_ctx->search_maxlen = patlen;
+            if (mpm_ctx->search_minlen == 0) mpm_ctx->search_minlen = patlen;
+            else if (mpm_ctx->search_minlen > patlen) mpm_ctx->search_minlen = patlen;
+        }
+    } else {
+        /* if we're reusing a pattern, check we need to check that it is a
+         * scan pattern if that is what we're adding. If so we set the pattern
+         * to be a scan pattern. */
+        if (scan) {
+            p->flags |= B3G_SCAN;
+
+            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
+            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
+            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
+        }
+    }
+
+    /* we need a match */
+    B3gEndMatchAppend(mpm_ctx, p, offset, depth, pid, sid, nosearch);
+
+    mpm_ctx->total_pattern_cnt++;
+    return 0;
+
+error:
+    B3gFreePattern(mpm_ctx, p);
+    return -1;
+}
+
+/*
+static inline int
+memcmp_lowercase(uint8_t *s1, uint8_t *s2, uint16_t n) {
+    size_t i;
+
+    * check backwards because we already tested the first
+     * 2 to 4 chars. This way we are more likely to detect
+     * a miss and thus speed up a little... *
+    for (i = n - 1; i; i--) {
+        if (u8_tolower(*(s2+i)) != s1[i])
+            return 1;
+    }
+
+    return 0;
+}
+*/
+
+static inline uint32_t B3gScanWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
+    B3gCtx *ctx = (B3gCtx *)mpm_ctx->ctx;
+    return ctx->Scan(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen);
+}
+
+static inline uint32_t B3gSearchWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
+    B3gCtx *ctx = (B3gCtx *)mpm_ctx->ctx;
+    return ctx->Search(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen);
+}
+
 
 #endif
 
diff --git a/src/util-mpm-wumanber.c b/src/util-mpm-wumanber.c
index b735bdc..777589d 100644
--- a/src/util-mpm-wumanber.c
+++ b/src/util-mpm-wumanber.c
@@ -24,8 +24,6 @@
 #include "util-unittest.h"
 #include "util-debug.h"
 
-#define INIT_HASH_SIZE 65535
-
 #define HASH16_SIZE 65536
 #define HASH16(a,b) (((a)<<8) | (b))
 #define HASH15_SIZE 32768
@@ -49,8 +47,6 @@ int WmAddScanPatternCS(MpmCtx *, uint8_t *, uint16_t, uint16_t, uint16_t, uint32
 int WmAddPatternCI(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen, uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid);
 int WmAddPatternCS(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen, uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid);
 int WmPreparePatterns(MpmCtx *mpm_ctx);
-inline uint32_t WmScan(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
-inline uint32_t WmSearch(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
 uint32_t WmScan1(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
 uint32_t WmScan2Hash9(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
 uint32_t WmScan2Hash12(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
@@ -108,39 +104,6 @@ void MpmWuManberRegister (void) {
     }
 }
 
-/* append an endmatch to a pattern
- *
- * Only used in the initialization phase */
-static inline void WmEndMatchAppend(MpmCtx *mpm_ctx, WmPattern *p,
-    uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid,
-    uint8_t nosearch)
-{
-    MpmEndMatch *em = MpmAllocEndMatch(mpm_ctx);
-    if (em == NULL) {
-        printf("ERROR: WmAllocEndMatch failed\n");
-        return;
-    }
-
-    em->id = pid;
-    em->sig_id = sid;
-    em->depth = depth;
-    em->offset = offset;
-
-    if (nosearch)
-        em->flags |= MPM_ENDMATCH_NOSEARCH;
-
-    if (p->em == NULL) {
-        p->em = em;
-        return;
-    }
-
-    MpmEndMatch *m = p->em;
-    while (m->next) {
-        m = m->next;
-    }
-    m->next = em;
-}
-
 void prt (uint8_t *buf, uint16_t buflen) {
     uint16_t i;
 
@@ -208,33 +171,6 @@ void WmPrintInfo(MpmCtx *mpm_ctx) {
     printf("\n");
 }
 
-static inline WmPattern *WmAllocPattern(MpmCtx *mpm_ctx) {
-    WmPattern *p = SCMalloc(sizeof(WmPattern));
-    if (p == NULL) {
-        printf("ERROR: WmAllocPattern: SCMalloc failed\n");
-        exit(EXIT_FAILURE);
-    }
-    memset(p,0,sizeof(WmPattern));
-
-    mpm_ctx->memory_cnt++;
-    mpm_ctx->memory_size += sizeof(WmPattern);
-    return p;
-}
-
-static inline WmHashItem *
-WmAllocHashItem(MpmCtx *mpm_ctx) {
-    WmHashItem *hi = SCMalloc(sizeof(WmHashItem));
-    if (hi == NULL) {
-        printf("ERROR: WmAllocHashItem: SCMalloc failed\n");
-        exit(EXIT_FAILURE);
-    }
-    memset(hi,0,sizeof(WmHashItem));
-
-    mpm_ctx->memory_cnt++;
-    mpm_ctx->memory_size += sizeof(WmHashItem);
-    return hi;
-}
-
 static void WmHashFree(MpmCtx *mpm_ctx, WmHashItem *hi) {
     if (hi == NULL)
         return;
@@ -247,95 +183,6 @@ static void WmHashFree(MpmCtx *mpm_ctx, WmHashItem *hi) {
     SCFree(hi);
 }
 
-static inline void memcpy_tolower(uint8_t *d, uint8_t *s, uint16_t len) {
-    uint16_t i;
-    for (i = 0; i < len; i++) {
-        d[i] = wm_tolower(s[i]);
-    }
-}
-
-/*
- * INIT HASH START
- */
-static inline uint32_t WmInitHash(WmPattern *p) {
-    uint32_t hash = p->len * p->cs[0];
-    if (p->len > 1)
-        hash += p->cs[1];
-
-    return (hash % INIT_HASH_SIZE);
-}
-
-static inline uint32_t WmInitHashRaw(uint8_t *pat, uint16_t patlen) {
-    uint32_t hash = patlen * pat[0];
-    if (patlen > 1)
-        hash += pat[1];
-
-    return (hash % INIT_HASH_SIZE);
-}
-
-static inline int WmInitHashAdd(WmCtx *ctx, WmPattern *p) {
-    uint32_t hash = WmInitHash(p);
-
-    //printf("WmInitHashAdd: %" PRIu32 "\n", hash);
-
-    if (ctx->init_hash[hash] == NULL) {
-        ctx->init_hash[hash] = p;
-        //printf("WmInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
-        return 0;
-    }
-
-    WmPattern *tt = NULL;
-    WmPattern *t = ctx->init_hash[hash];
-
-    /* get the list tail */
-    do {
-        tt = t;
-        t = t->next;
-    } while (t != NULL);
-
-    tt->next = p;
-    //printf("WmInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
-
-    return 0;
-}
-
-static inline int WmCmpPattern(WmPattern *p, uint8_t *pat, uint16_t patlen, char nocase);
-
-static inline WmPattern *WmInitHashLookup(WmCtx *ctx, uint8_t *pat, uint16_t patlen, char nocase) {
-    uint32_t hash = WmInitHashRaw(pat,patlen);
-
-    //printf("WmInitHashLookup: %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
-
-    if (ctx->init_hash[hash] == NULL) {
-        return NULL;
-    }
-
-    WmPattern *t = ctx->init_hash[hash];
-    for ( ; t != NULL; t = t->next) {
-        if (WmCmpPattern(t,pat,patlen,nocase) == 1)
-            return t;
-    }
-
-    return NULL;
-}
-
-static inline int WmCmpPattern(WmPattern *p, uint8_t *pat, uint16_t patlen, char nocase) {
-    if (p->len != patlen)
-        return 0;
-
-    if (!((nocase && p->flags & WUMANBER_NOCASE) || (!nocase && !(p->flags & WUMANBER_NOCASE))))
-        return 0;
-
-    if (memcmp(p->cs, pat, patlen) != 0)
-        return 0;
-
-    return 1;
-}
-
-/*
- * INIT HASH END
- */
-
 void WmFreePattern(MpmCtx *mpm_ctx, WmPattern *p) {
     if (p && p->em) {
         MpmEndMatchFreeAll(mpm_ctx, p->em);
@@ -360,110 +207,6 @@ void WmFreePattern(MpmCtx *mpm_ctx, WmPattern *p) {
     }
 }
 
-/* WmAddPattern
- *
- * pat: ptr to the pattern
- * patlen: length of the pattern
- * nocase: nocase flag: 1 enabled, 0 disable
- * pid: pattern id
- * sid: signature id (internal id)
- */
-static inline int WmAddPattern(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen, uint16_t offset, uint16_t depth, char nocase, char scan, uint32_t pid, uint32_t sid, uint8_t nosearch) {
-    WmCtx *ctx = (WmCtx *)mpm_ctx->ctx;
-
-//    printf("WmAddPattern: ctx %p \"", mpm_ctx); prt(pat, patlen);
-//    printf("\" id %" PRIu32 ", nocase %s\n", id, nocase ? "true" : "false");
-
-    if (patlen == 0)
-        return 0;
-
-    /* get a memory piece */
-    WmPattern *p = WmInitHashLookup(ctx, pat, patlen, nocase);
-    if (p == NULL) {
-//        printf("WmAddPattern: allocing new pattern\n");
-        p = WmAllocPattern(mpm_ctx);
-        if (p == NULL)
-            goto error;
-
-        p->len = patlen;
-
-        if (nocase) p->flags |= WUMANBER_NOCASE;
-
-        /* setup the case insensitive part of the pattern */
-        p->ci = SCMalloc(patlen);
-        if (p->ci == NULL) goto error;
-        mpm_ctx->memory_cnt++;
-        mpm_ctx->memory_size += patlen;
-        memcpy_tolower(p->ci, pat, patlen);
-
-        /* setup the case sensitive part of the pattern */
-        if (p->flags & WUMANBER_NOCASE) {
-            /* nocase means no difference between cs and ci */
-            p->cs = p->ci;
-        } else {
-            if (memcmp(p->ci,pat,p->len) == 0) {
-                /* no diff between cs and ci: pat is lowercase */
-                p->cs = p->ci;
-            } else {
-                p->cs = SCMalloc(patlen);
-                if (p->cs == NULL) goto error;
-                mpm_ctx->memory_cnt++;
-                mpm_ctx->memory_size += patlen;
-                memcpy(p->cs, pat, patlen);
-            }
-        }
-
-        if (p->len > 1) {
-            p->prefix_cs = (uint16_t)(*(p->cs)+*(p->cs+1));
-            p->prefix_ci = (uint16_t)(*(p->ci)+*(p->ci+1));
-        }
-
-        //printf("WmAddPattern: ci \""); prt(p->ci,p->len);
-        //printf("\" cs \""); prt(p->cs,p->len);
-        //printf("\" prefix_ci %" PRIu32 ", prefix_cs %" PRIu32 "\n", p->prefix_ci, p->prefix_cs);
-
-        /* put in the pattern hash */
-        WmInitHashAdd(ctx, p);
-
-        if (mpm_ctx->pattern_cnt == 65535) {
-            printf("Max search words reached\n");
-            exit(1);
-        }
-        mpm_ctx->pattern_cnt++;
-
-        if (scan) { /* SCAN */
-            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
-            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
-            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
-            p->flags |= WUMANBER_SCAN;
-        } else { /* SEARCH */
-            if (mpm_ctx->search_maxlen < patlen) mpm_ctx->search_maxlen = patlen;
-            if (mpm_ctx->search_minlen == 0) mpm_ctx->search_minlen = patlen;
-            else if (mpm_ctx->search_minlen > patlen) mpm_ctx->search_minlen = patlen;
-        }
-    } else {
-        /* if we're reusing a pattern, check we need to check that it is a
-         * scan pattern if that is what we're adding. If so we set the pattern
-         * to be a scan pattern. */
-        if (scan) {
-            p->flags = WUMANBER_SCAN;
-            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
-            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
-            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
-        }
-    }
-
-    /* we need a match */
-    WmEndMatchAppend(mpm_ctx, p, offset, depth, pid, sid, nosearch);
-
-    mpm_ctx->total_pattern_cnt++;
-    return 0;
-
-error:
-    WmFreePattern(mpm_ctx, p);
-    return -1;
-}
-
 int WmAddScanPatternCI(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen,
     uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid, uint8_t nosearch)
 {
@@ -900,7 +643,7 @@ int WmPreparePatterns(MpmCtx *mpm_ctx) {
 
     /* populate it with the patterns in the hash */
     uint32_t i = 0, p = 0;
-    for (i = 0; i < INIT_HASH_SIZE; i++) {
+    for (i = 0; i < WM_INIT_HASH_SIZE; i++) {
         WmPattern *node = ctx->init_hash[i], *nnode = NULL;
         for ( ; node != NULL; ) {
             nnode = node->next;
@@ -1022,31 +765,6 @@ void WmPrintSearchStats(MpmThreadCtx *mpm_thread_ctx) {
 #endif /* WUMANBER_COUNTERS */
 }
 
-static inline int
-memcmp_lowercase(uint8_t *s1, uint8_t *s2, uint16_t n) {
-    size_t i;
-
-    /* check backwards because we already tested the first
-     * 2 to 4 chars. This way we are more likely to detect
-     * a miss and thus speed up a little... */
-    for (i = n - 1; i; i--) {
-        if (wm_tolower(*(s2+i)) != s1[i])
-            return 1;
-    }
-
-    return 0;
-}
-
-inline uint32_t WmScan(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
-    WmCtx *ctx = (WmCtx *)mpm_ctx->ctx;
-    return ctx->Scan(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen);
-}
-
-inline uint32_t WmSearch(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
-    WmCtx *ctx = (WmCtx *)mpm_ctx->ctx;
-    return ctx->Search(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen);
-}
-
 /* SCAN FUNCTIONS */
 uint32_t WmScan2Hash9(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
     WmCtx *ctx = (WmCtx *)mpm_ctx->ctx;
@@ -2244,11 +1962,11 @@ void WmInitCtx (MpmCtx *mpm_ctx, int module_handle) {
 
     /* initialize the hash we use to speed up pattern insertions */
     WmCtx *ctx = (WmCtx *)mpm_ctx->ctx;
-    ctx->init_hash = SCMalloc(sizeof(WmPattern *) * INIT_HASH_SIZE);
+    ctx->init_hash = SCMalloc(sizeof(WmPattern *) * WM_INIT_HASH_SIZE);
     if (ctx->init_hash == NULL)
         return;
 
-    memset(ctx->init_hash, 0, sizeof(WmPattern *) * INIT_HASH_SIZE);
+    memset(ctx->init_hash, 0, sizeof(WmPattern *) * WM_INIT_HASH_SIZE);
 
     /* Initialize the defaults value from the config file. The given check make
        sure that we query config file only once for config values */
@@ -2265,7 +1983,7 @@ void WmDestroyCtx(MpmCtx *mpm_ctx) {
     if (ctx->init_hash) {
         SCFree(ctx->init_hash);
         mpm_ctx->memory_cnt--;
-        mpm_ctx->memory_size -= (INIT_HASH_SIZE * sizeof(WmPattern *));
+        mpm_ctx->memory_size -= (WM_INIT_HASH_SIZE * sizeof(WmPattern *));
     }
 
     if (ctx->parray) {
